import { classNamesFunction } from '@uifabric-vue/utilities';
import { ref } from '@vue/composition-api';
import { useId } from '../../composition/useId';
import { useControllableValue } from '@/composition/useControllableValue';
export var ONKEYDOWN_TIMEOUT_DURATION = 1000;
var getClassNames = classNamesFunction();
var getSlotStyleFn = function (sty) {
    return function (value) {
        var _a;
        return _a = {},
            _a[sty] = value + "%",
            _a;
    };
};
var getPositionStyleFn = function (vertical, rtl) {
    if (vertical === void 0) { vertical = false; }
    if (rtl === void 0) { rtl = false; }
    if (vertical) {
        return getSlotStyleFn('bottom');
    }
    return getSlotStyleFn(rtl ? 'right' : 'left');
};
var getPercent = function (value, sliderMin, sliderMax) {
    return sliderMax === sliderMin ? 0 : ((value - sliderMin) / (sliderMax - sliderMin)) * 100;
};
var getLineSectionStylesFn = function (vertical) {
    if (vertical === void 0) { vertical = false; }
    var lengthString = vertical ? 'height' : 'width';
    return getSlotStyleFn(lengthString);
};
export var useSlider = function (props) {
    var _a = props.step, step = _a === void 0 ? 1 : _a, className = props.className, _b = props.disabled, disabled = _b === void 0 ? false : _b, label = props.label, _c = props.max, max = _c === void 0 ? 10 : _c, _d = props.min, min = _d === void 0 ? 0 : _d, _e = props.showValue, showValue = _e === void 0 ? true : _e, _f = props.buttonProps, buttonProps = _f === void 0 ? {} : _f, _g = props.vertical, vertical = _g === void 0 ? false : _g, valueFormat = props.valueFormat, styles = props.styles, theme = props.theme, originFromZero = props.originFromZero, ariaLabel = props.ariaLabel;
    var disposable = ref([]);
    var sliderLine = ref();
    var _h = useControllableValue(props.value, props.defaultValue, function (ev, v) { return props.onChange && props.onChange(v); }), unclampedValue = _h[0], setValue = _h[1];
    // Ensure that value is always a number and is clamped by min/max.
    var value = Math.max(min, Math.min(max, unclampedValue || 0));
    var id = useId('Slider');
};
//# sourceMappingURL=useSlider.js.map