import { Vue } from 'vue-property-decorator';
import { IToggleStyles } from './Toggle.types';
import { CreateElement } from 'vue';
import { ITheme } from '@uifabric/styling';
export declare class ToggleBase extends Vue {
    $refs: {
        toggleButton: HTMLButtonElement;
    };
    readonly className: string;
    readonly styles: any;
    readonly theme: ITheme;
    checked: boolean;
    label: string;
    defaultChecked: boolean;
    disabled: boolean;
    inlineLabel: boolean;
    onText: string;
    offText: string;
    internalChecked: boolean;
    onCheckedChanged(checked: boolean): void;
    protected get uid(): number;
    get classNames(): import("@uifabric/styling").IProcessedStyleSet<IToggleStyles>;
    render(h: CreateElement): import("vue").VNode;
    focus(): void;
    private onClick;
}
//# sourceMappingURL=Toggle.base.d.ts.map